
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : adobe-fonts.scm
;; DESCRIPTION : setup TeX adobe postscript fonts
;; COPYRIGHT   : (C) 1999  Joris van der Hoeven
;;
;; This software falls under the GNU general public licence and comes WITHOUT
;; ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(set-font-rules
  '(((avant-garde rm medium right $s $d) (tex rpagk $s $d 0))
    ((avant-garde rm medium slanted $s $d) (tex rpagko $s $d 0))
    ((avant-garde rm medium italic $s $d) (tex rpagko $s $d 0))
    ((avant-garde rm bold right $s $d) (tex rpagd $s $d 0))
    ((avant-garde rm bold slanted $s $d) (tex rpagdo $s $d 0))
    ((avant-garde rm bold italic $s $d) (tex rpagdo $s $d 0))

    ((bookman rm medium right $s $d) (tex rpbkl $s $d 0))
    ((bookman rm medium slanted $s $d) (tex rpbkli $s $d 0))
    ((bookman rm medium italic $s $d) (tex rpbkli $s $d 0))
    ((bookman rm bold right $s $d) (tex rpbkd $s $d 0))
    ((bookman rm bold slanted $s $d) (tex rpbkdi $s $d 0))
    ((bookman rm bold italic $s $d) (tex rpbkdi $s $d 0))

    ((courier rm medium right $s $d) (tex rpcrr $s $d 0))
    ((courier rm medium slanted $s $d) (tex rpcrro $s $d 0))
    ((courier rm medium italic $s $d) (tex rpcrro $s $d 0))
    ((courier rm bold right $s $d) (tex rpcrb $s $d 0))
    ((courier rm bold slanted $s $d) (tex rpcrbo $s $d 0))
    ((courier rm bold italic $s $d) (tex rpcrbo $s $d 0))

    ((helvetica rm medium right $s $d) (tex rphvr $s $d 0))
    ((helvetica rm medium slanted $s $d) (tex rphvro $s $d 0))
    ((helvetica rm medium italic $s $d) (tex rphvro $s $d 0))
    ((helvetica rm medium condensed $s $d) (tex rphvrrn $s $d 0))
    ((helvetica rm medium slanted-condensed $s $d) (tex rphvron $s $d 0))
    ((helvetica rm medium italic-condensed $s $d) (tex rphvron $s $d 0))
    ((helvetica rm bold right $s $d) (tex rphvb $s $d 0))
    ((helvetica rm bold slanted $s $d) (tex rphvbo $s $d 0))
    ((helvetica rm bold italic $s $d) (tex rphvbo $s $d 0))
    ((helvetica rm bold condensed $s $d) (tex rphvbrn $s $d 0))
    ((helvetica rm bold slanted-condensed $s $d) (tex rphvbon $s $d 0))
    ((helvetica rm bold italic-condensed $s $d) (tex rphvbon $s $d 0))
    
    ((new-century-schoolbook rm medium right $s $d) (tex rpncr $s $d 0))
    ((new-century-schoolbook rm medium slanted $s $d) (tex rpncri $s $d 0))
    ((new-century-schoolbook rm medium italic $s $d) (tex rpncri $s $d 0))
    ((new-century-schoolbook rm bold right $s $d) (tex rpncb $s $d 0))
    ((new-century-schoolbook rm bold slanted $s $d) (tex rpncbi $s $d 0))
    ((new-century-schoolbook rm bold italic $s $d) (tex rpncbi $s $d 0))

    ((palatino rm medium right $s $d) (tex rpplr $s $d 0))
    ((palatino rm medium slanted $s $d) (tex rpplro $s $d 0))
    ((palatino rm medium italic $s $d) (tex rpplri $s $d 0))
    ((palatino rm medium italic-right $s $d) (tex rpplru $s $d 0))
    ((palatino rm medium condensed $s $d) (tex rpplrrn $s $d 0))
    ((palatino rm medium wide $s $d) (tex rpplrre $s $d 0))
    ((palatino rm bold right $s $d) (tex rpplb $s $d 0))
    ((palatino rm bold slanted $s $d) (tex rpplbi $s $d 0))
    ((palatino rm bold italic $s $d) (tex rpplbi $s $d 0))
    ((palatino rm bold italic-right $s $d) (tex rpplbu $s $d 0))

    ((times rm medium right $s $d) (tex rptmr $s $d 0))
    ((times rm medium slanted $s $d) (tex rptmro $s $d 0))
    ((times rm medium italic $s $d) (tex rptmri $s $d 0))
    ((times rm medium condensed $s $d) (tex rptmrrn $s $d 0))
    ((times rm medium wide $s $d) (tex rptmrre $s $d 0))
    ((times rm bold right $s $d) (tex rptmb $s $d 0))
    ((times rm bold slanted $s $d) (tex rptmbo $s $d 0))
    ((times rm bold italic $s $d) (tex rptmbi $s $d 0))

    ((chancellary rm $a $b $s $d) (tex rpzcmi $s $d 0))
    ((dingbat rm $a $b $s $d) (tex rpzdr $s $d 0))))


(set-font-rules
  '(((adobe mr medium $a $s $d)
     (math
      (adobe-math (tex cmr $s $d)
		  (tex cmmi $s $d)
		  (tex cmsy $s $d)
		  (tex msam $s $d)
		  (tex msbm $s $d)
		  (tex stmary $s $d)
		  (tex wasy $s $d)
		  (tex line $s $d)
		  (virtual long $s $d)
		  (virtual negate $s $d)
		  (virtual misc $s $d)
		  (tex rptmri $s $d 0)
		  (tex rpsyr $s $d 0)
		  (tex rpsyro $s $d 0))
      (rubber (tex-rubber rubber-cmex cmex $s $d)
	      (tex-rubber rubber-stmary stmary $s $d)
	      (tex-rubber rubber-wasy wasy $s $d))
      (tex rptmr $s $d 0)
      (tex rptmr $s $d 0)))

    ((adobe mr bold $a $s $d)
     (math
      (adobe-math (tex cmbx $s $d)
		  (tex cmmib $s $d)
		  (tex cmbsy $s $d)
		  (tex msam $s $d)
		  (tex msbm $s $d)
		  (tex stmaryb $s $d)
		  (tex wasyb $s $d)
		  (tex lineb $s $d)
		  (virtual long $s $d)
		  (virtual negate $s $d)
		  (virtual misc $s $d)
		  (tex rptmbi $s $d 0)
		  (tex rpsyr $s $d 0)
		  (tex rpsyro $s $d 0))
      (rubber (tex-rubber rubber-cmex cmexb $s $d)
	      (tex-rubber rubber-stmary stmaryb $s $d)
	      (tex-rubber rubber-wasy wasyb $s $d))
      (tex rptmb $s $d 0)
      (tex rptmb $s $d 0)))))
