
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : accents.scm
;; DESCRIPTION : setup shorthands for accented characters
;; COPYRIGHT   : (C) 1999  Joris van der Hoeven
;;
;; This software falls under the GNU general public licence and comes WITHOUT
;; ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(set-shorthands '(text) "<" ">"
  '(("<esc>" "" "execute a TeXmacs command")
    ("<esc><esc>" "" "insert a TeXmacs symbol")

    ("<alt-s>" "")
    ("<alt-S>" "SS")
    ("<alt-a>" "")
    ("<alt-a><alt-e>" "")
    ("<alt-o>" "")
    ("<alt-o><alt-e>" "")
    ("<alt-A>" "")
    ("<alt-A><alt-E>" "")
    ("<alt-O>" "")
    ("<alt-O><alt-E>" "")
    ("<alt-!>" "")
    ("<alt-?>" "")
    ("<esc>~" "~")
    ("<esc>~A" "")
    ("<esc>~N" "")
    ("<esc>~O" "")
    ("<esc>~a" "")
    ("<esc>~n" "")
    ("<esc>~o" "")

    ("<esc>^" "^")
    ("<esc>^A" "")
    ("<esc>^E" "")
    ("<esc>^I" "")
    ("<esc>^O" "")
    ("<esc>^U" "")
    ("<esc>^a" "")
    ("<esc>^e" "")
    ("<esc>^i" "")
    ("<esc>^o" "")
    ("<esc>^u" "")

    ("<esc>" "''")
    ("<esc>A" "")
    ("<esc>E" "")
    ("<esc>I" "")
    ("<esc>O" "")
    ("<esc>U" "")
    ("<esc>Y" "")
    ("<esc>a" "")
    ("<esc>e" "")
    ("<esc>i" "")
    ("<esc>o" "")
    ("<esc>u" "")
    ("<esc>y" "")

    ("<esc>\"" "''")
    ("<esc>\"A" "")
    ("<esc>\"E" "")
    ("<esc>\"I" "")
    ("<esc>\"O" "")
    ("<esc>\"U" "")
    ("<esc>\"Y" "")
    ("<esc>\"a" "")
    ("<esc>\"e" "")
    ("<esc>\"i" "")
    ("<esc>\"o" "")
    ("<esc>\"u" "")
    ("<esc>\"y" "")

    ("<esc>'" "'")
    ("<esc>'A" "")
    ("<esc>'C" "")
    ("<esc>'E" "")
    ("<esc>'I" "")
    ("<esc>'L" "")
    ("<esc>'N" "")
    ("<esc>'O" "")
    ("<esc>'R" "")
    ("<esc>'S" "")
    ("<esc>'U" "")
    ("<esc>'Y" "")
    ("<esc>'Z" "")
    ("<esc>'a" "")
    ("<esc>'c" "")
    ("<esc>'e" "")
    ("<esc>'i" "")
    ("<esc>'l" "")
    ("<esc>'n" "")
    ("<esc>'o" "")
    ("<esc>'r" "")
    ("<esc>'s" "")
    ("<esc>'u" "")
    ("<esc>'y" "")
    ("<esc>'z" "")

    ("<esc>`" "`")
    ("<esc>`A" "")
    ("<esc>`E" "")
    ("<esc>`I" "")
    ("<esc>`O" "")
    ("<esc>`U" "")
    ("<esc>`a" "")
    ("<esc>`e" "")
    ("<esc>`i" "")
    ("<esc>`o" "")
    ("<esc>`u" "")

    ("<esc>c" "")
    ("<esc>cC" "")
    ("<esc>cS" "")
    ("<esc>cT" "")
    ("<esc>cc" "")
    ("<esc>cs" "")
    ("<esc>ct" "")

    ("<esc>u" "")
    ("<esc>uA" "")
    ("<esc>uG" "")
    ("<esc>ua" "")
    ("<esc>ug" "")

    ("<esc>v" "")
    ("<esc>vC" "")
    ("<esc>vD" "")
    ("<esc>vE" "")
    ("<esc>vN" "")
    ("<esc>vR" "")
    ("<esc>vS" "")
    ("<esc>vZ" "")
    ("<esc>vc" "")
    ("<esc>ve" "")
    ("<esc>vn" "")
    ("<esc>vr" "")
    ("<esc>vs" "")
    ("<esc>vz" "")

    ("<esc>H" "}")
    ("<esc>HO" "")
    ("<esc>HU" "")
    ("<esc>Ho" "")
    ("<esc>Hu" "")

    ("<esc>o" "")
    ("<esc>oA" "")
    ("<esc>oU" "")
    ("<esc>oa" "")
    ("<esc>ou" "")

    ("<esc>." "_")
    ("<esc>.Z" "")
    ("<esc>.I" "")
    ("<esc>.z" "")))
