
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : emacs.scm
;; DESCRIPTION : emacs control keys
;; COPYRIGHT   : (C) 1999  Joris van der Hoeven
;;
;; This software falls under the GNU general public licence and comes WITHOUT
;; ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(set-shorthands '(text math prog) "<" ">"
  '(("<ctrl-c>" "" "emacs mode specific prefix command")
    ("<ctrl-x>" "" "emacs prefix command")))

(define (kill-line)
  (selection-set-start)
  (go-end-line)
  (selection-set-end)
  (cut))

(set-keymap '(text math prog)
  '(("<ctrl-a>" (go-home-line))
    ("<ctrl-b>" (go-left))
    ("<ctrl-e>" (go-end-line))
    ("<ctrl-f>" (go-right))
    ("<ctrl-j>" (insert-return))
    ("<ctrl-k>" (kill-line))
    ("<ctrl-l>" (recenter-window))
    ("<ctrl-n>" (go-down))
    ("<ctrl-o>" (open-line))
    ("<ctrl-p>" (go-up))
    ("<ctrl-r>" (search-backward))
    ("<ctrl-s>" (search-forward))
    ("<ctrl-t>" (transpose-chars))
    ("<ctrl-v>" (go-page-up))
    ("<ctrl-w>" (begin (selection-set-end) (cut)))
    ("<ctrl-y>" (paste))
    ("<ctrl-\\>" (toggle-input-method))
    ("<ctrl-]>" (abort-recursive-edit))
    ("<ctrl-_>" (undo))
    ("<ctrl-/>" (undo))
    ("<ctrl-spc>" (selection-set-start))
    ("<ctrl-insert>" (selection-set-end))

    ("<ctrl-x><ctrl-c>"
      (if (exists-unsaved-buffer)
	(interactive
          '("There are unsaved files. Really quit?")
          'quit-TeXmacs-confirm)
	(quit-TeXmacs)))
    ("<ctrl-x><ctrl-f>" (interactive '("File name:") 'load-texmacs-buffer))
    ("<ctrl-x><ctrl-s>" (save-texmacs-buffer (get-name-buffer)))
    ("<ctrl-x><ctrl-w>" (interactive '("Save as:") 'save-texmacs-buffer))))
