
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : keymaps.scm
;; DESCRIPTION : setup shorthands for many mathematical symbols
;; COPYRIGHT   : (C) 1999  Joris van der Hoeven
;;
;; This software falls under the GNU general public licence and comes WITHOUT
;; ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(set-shorthands '(math) "<" ">"
  '(("<esc>" "" "execute a TeXmacs command")
    ("<esc><esc>" "" "insert a TeXmacs symbol")
    ("<esc><esc>l" "" "insert a large left delimiter")
    ("<esc><esc>m" "" "insert a large separator")
    ("<esc><esc>r" "" "insert a large right delimiter")
    ("<esc><esc>" "" "insert a TeXmacs symbol")
    ("<esc>L" "" "insert a left subscript")

    ("(" "(")
    (")" ")")
    ("[" "[")
    ("]" "]")
    ("{" "{")
    ("}" "}")
    ("|," "<lfloor>")
    ("|'" "<lceil>")
    (",|" "<rfloor>")
    ("'|" "<rceil>")
    ("[[*" "<[[>")
    ("]]*" "<]]>")

    ("<alt-a>" "<alpha>")
    ("<alt-b>" "<beta>")
    ("<alt-g>" "<gamma>")
    ("<alt-d>" "<delta>")
    ("<alt-e>" "<varepsilon>")
    ("<alt-e>*" "<epsilon>")
    ("<alt-e>**" "<backepsilon>")
    ("<alt-z>" "<zeta>")
    ("<alt-h>" "<eta>")
    ("<alt-q>" "<theta>")
    ("<alt-q>*" "<vartheta>")
    ("<alt-j>" "<theta>")
    ("<alt-j>*" "<vartheta>")
    ("<alt-i>" "<iota>")
    ("<alt-k>" "<kappa>")
    ("<alt-k>*" "<varkappa>")
    ("<alt-l>" "<lambda>")
    ("<alt-m>" "<mu>")
    ("<alt-n>" "<nu>")
    ("<alt-x>" "<xi>")
    ("<alt-o>" "<omicron>")
    ("<alt-p>" "<pi>")
    ("<alt-p>*" "<varpi>")
    ("<alt-r>" "<rho>")
    ("<alt-r>*" "<varrho>")
    ("<alt-s>" "<sigma>")
    ("<alt-s>*" "<varsigma>")
    ("<alt-t>" "<tau>")
    ("<alt-u>" "<upsilon>")
    ("<alt-f>" "<varphi>")
    ("<alt-f>*" "<phi>")
    ("<alt-y>" "<psi>")
    ("<alt-c>" "<chi>")
    ("<alt-w>" "<omega>")
    ("<alt-v>" "<omega>")

    ("<alt-A>" "<Alpha>")
    ("<alt-B>" "<Beta>")
    ("<alt-G>" "<Gamma>")
    ("<alt-D>" "<Delta>")
    ("<alt-E>" "<Epsilon>")
    ("<alt-Z>" "<Zeta>")
    ("<alt-H>" "<Eta>")
    ("<alt-Q>" "<Theta>")
    ("<alt-J>" "<Theta>")
    ("<alt-I>" "<Iota>")
    ("<alt-K>" "<Kappa>")
    ("<alt-L>" "<Lambda>")
    ("<alt-M>" "<Mu>")
    ("<alt-N>" "<Nu>")
    ("<alt-X>" "<Xi>")
    ("<alt-O>" "<Omicron>")
    ("<alt-P>" "<Pi>")
    ("<alt-R>" "<Rho>")
    ("<alt-S>" "<Sigma>")
    ("<alt-T>" "<Tau>")
    ("<alt-U>" "<Upsilon>")
    ("<alt-F>" "<Phi>")
    ("<alt-Y>" "<Psi>")
    ("<alt-C>" "<Chi>")
    ("<alt-W>" "<Omega>")
    ("<alt-V>" "<Omega>")

    ("<esc><esc>a" "<amalg>")
    ("<esc><esc>d" "<partial>")
    ("<esc><esc>n" "<cap>")
    ("<esc><esc>n*" "<wedge>")
    ("<esc><esc>n**" "<sqcap>")
    ("<esc><esc>n***" "<curlywedge>")
    ("<esc><esc>n****" "<curlywedgeuparrow>")
    ("<esc><esc>n*****" "<curlywedgedownarrow>")
    ("<esc><esc>u" "<cup>")
    ("<esc><esc>u*" "<vee>")
    ("<esc><esc>u**" "<sqcup>")
    ("<esc><esc>u***" "<curlyvee>")
    ("<esc><esc>u****" "<curlyveeuparrow>")
    ("<esc><esc>u*****" "<curlyveedownarrow>")
    ("<esc><esc>n*<esc><esc>n" "<wedges>")
    ("<esc><esc>w" "<wp>")
    ("<esc><esc>x" "<times>")

    ("<esc><esc>S" "<big-sum>")
    ("<esc><esc>P" "<big-prod>")
    ("<esc><esc>I" "<big-int>")
    ("<esc><esc>I*" "<big-intwl>")
    ("<esc><esc>I@" "<big-oint>")
    ("<esc><esc>I@*" "<big-ointwl>")
    ("<esc><esc>O" "<big-oint>")
    ("<esc><esc>O*" "<big-ointwl>")
    ("<esc><esc>A" "<big-amalg>")
    ("<esc><esc>N" "<big-cap>")
    ("<esc><esc>N*" "<big-wedge>")
    ("<esc><esc>N**" "<big-sqcap>")
    ("<esc><esc>N***" "<big-curlywedge>")
    ("<esc><esc>N****" "<big-triangleup>")
    ("<esc><esc>U" "<big-cup>")
    ("<esc><esc>U*" "<big-vee>")
    ("<esc><esc>U**" "<big-sqcup>")
    ("<esc><esc>U***" "<big-curlyvee>")
    ("<esc><esc>U****" "<big-triangledown>")
    ("<esc><esc>@" "<bigcirc>")
    ("<esc><esc>@." "<big-odot>")
    ("<esc><esc>@+" "<big-oplus>")
    ("<esc><esc>@x" "<big-otimes>")
    ("<esc><esc>@*" "<big-box>")
    ("<esc><esc>N+" "<big-pluscap>")
    ("<esc><esc>U+" "<big-pluscup>")
    ("<esc><esc>||*" "<big-parallel>")
    ("<esc><esc>|||" "<big-interleave>")

    ("<esc><esc>(" "<left-(>")
    ("<esc><esc>)" "<right-)>")
    ("<esc><esc>[" "<left-[>")
    ("<esc><esc>]" "<right-]>")
    ("<esc><esc>{" "<left-{>")
    ("<esc><esc>}" "<right-}>")
    ("<esc><esc>[[" "<left-[><left-[>")
    ("<esc><esc>[[*" "<left-llbracket>")
    ("<esc><esc>]]" "<right-]><right-]>")
    ("<esc><esc>]]*" "<right-rrbracket>")
    ("<esc><esc><less>" "<left-langle>")
    ("<esc><esc><gtr>" "<right-rangle>")
    ("<esc><esc>/" "<mid-/>")
    ("<esc><esc>b" "<mid-\\>")
    ("<esc><esc>|" "<mid-|>")
    ("<esc><esc>||" "<mid-||>")
    ("<esc><esc>|," "<left-lfloor>")
    ("<esc><esc>|'" "<left-lceil>")
    ("<esc><esc>,|" "<right-rfloor>")
    ("<esc><esc>'|" "<right-rceil>")

    ("<esc><esc>l(" "<left-(>")
    ("<esc><esc>l)" "<left-)>")
    ("<esc><esc>l[" "<left-[>")
    ("<esc><esc>l]" "<left-]>")
    ("<esc><esc>l{" "<left-{>")
    ("<esc><esc>l}" "<left-}>")
    ("<esc><esc>l[[" "<left-[><left-[>")
    ("<esc><esc>l[[*" "<left-llbracket>")
    ("<esc><esc>l]]" "<left-]><right-]>")
    ("<esc><esc>l]]*" "<left-rrbracket>")
    ("<esc><esc>l<less>" "<left-langle>")
    ("<esc><esc>l<gtr>" "<left-rangle>")
    ("<esc><esc>l/" "<left-/>")
    ("<esc><esc>lb" "<left-\\>")
    ("<esc><esc>l|" "<left-|>")
    ("<esc><esc>l||" "<left-||>")
    ("<esc><esc>l|," "<left-lfloor>")
    ("<esc><esc>l|'" "<left-lceil>")
    ("<esc><esc>l,|" "<left-rfloor>")
    ("<esc><esc>l'|" "<left-rceil>")
    ("<esc><esc>l." "<left-.>")

    ("<esc><esc>m(" "<mid-(>")
    ("<esc><esc>m)" "<mid-)>")
    ("<esc><esc>m[" "<mid-[>")
    ("<esc><esc>m]" "<mid-]>")
    ("<esc><esc>m{" "<mid-{>")
    ("<esc><esc>m}" "<mid-}>")
    ("<esc><esc>m[[" "<mid-[><mid-[>")
    ("<esc><esc>m[[*" "<mid-llbracket>")
    ("<esc><esc>m]]" "<mid-]><right-]>")
    ("<esc><esc>m]]*" "<mid-rrbracket>")
    ("<esc><esc>m<less>" "<mid-langle>")
    ("<esc><esc>m<gtr>" "<mid-rangle>")
    ("<esc><esc>m/" "<mid-/>")
    ("<esc><esc>mb" "<mid-\\>")
    ("<esc><esc>m|" "<mid-|>")
    ("<esc><esc>m||" "<mid-||>")
    ("<esc><esc>m|," "<mid-lfloor>")
    ("<esc><esc>m|'" "<mid-lceil>")
    ("<esc><esc>m,|" "<mid-rfloor>")
    ("<esc><esc>m'|" "<mid-rceil>")
    ("<esc><esc>m." "<mid-.>")

    ("<esc><esc>r(" "<right-(>")
    ("<esc><esc>r)" "<right-)>")
    ("<esc><esc>r[" "<right-[>")
    ("<esc><esc>r]" "<right-]>")
    ("<esc><esc>r{" "<right-{>")
    ("<esc><esc>r}" "<right-}>")
    ("<esc><esc>r[[" "<right-[><right-[>")
    ("<esc><esc>r[[*" "<right-llbracket>")
    ("<esc><esc>r]]" "<right-]><right-]>")
    ("<esc><esc>r]]*" "<right-rrbracket>")
    ("<esc><esc>r<less>" "<right-langle>")
    ("<esc><esc>r<gtr>" "<right-rangle>")
    ("<esc><esc>r/" "<right-/>")
    ("<esc><esc>rb" "<right-\\>")
    ("<esc><esc>r|" "<right-|>")
    ("<esc><esc>r||" "<right-||>")
    ("<esc><esc>r|," "<right-lfloor>")
    ("<esc><esc>r|'" "<right-lceil>")
    ("<esc><esc>r,|" "<right-rfloor>")
    ("<esc><esc>r'|" "<right-rceil>")
    ("<esc><esc>r." "<right-.>")))

(set-shorthands '(math) "<less>" "<gtr>"
  '(("<" "<less>")
    (">" "<gtr>")
    ("</" "<nless>")
    (">/" "<ngtr>")
    ("<=" "<leqslant>")
    (">=" "<geqslant>")
    ("<=/" "<nleqslant>")
    (">=/" "<ngeqslant>")
    ("<=*" "<leq>")
    (">=*" "<geq>")
    ("<=*/" "<nleq>")
    (">=*/" "<ngeq>")
    ("<<" "<ll>")
    ("<<<" "<lll>")
    (">>" "<gg>")
    (">>>" "<ggg>")
    ("<<=" "<lleq>")
    ("<<<=" "<llleq>")
    (">>=" "<ggeq>")
    (">>>=" "<gggeq>")
    ("<</" "<nll>")
    ("<<</" "<nlll>")
    (">>/" "<ngg>")
    (">>>/" "<nggg>")
    ("<<=/" "<nlleq>")
    ("<<<=/" "<nllleq>")
    (">>=/" "<nggeq>")
    (">>>=/" "<ngggeq>")
    ("<." "<lessdot>")
    (".>" "<gtrdot>")
    ("<=." "<lesseqdot>")
    (".>=" "<gtreqdot>")

    ("<*" "<prec>")
    (">*" "<succ>")
    ("<*/" "<nprec>")
    (">*/" "<nsucc>")
    ("<*=" "<preccurlyeq>")
    (">*=" "<succcurlyeq>")
    ("<*=/" "<npreccurlyeq>")
    (">*=/" "<nsucccurlyeq>")
    ("<*=*" "<preceq>")
    (">*=*" "<succeq>")
    ("<*=*/" "<npreceq>")
    (">*=*/" "<nsucceq>")
    ("<*=*/*" "<precneqq>")
    (">*=*/*" "<succneqq>")
    ("<<*" "<precprec>")
    ("<<<*" "<precprecprec>")
    (">>*" "<succsucc>")
    (">>>*" "<succsuccsucc>")
    ("<<*=" "<precpreceq>")
    ("<<<*=" "<precprecpreceq>")
    (">>*=" "<succsucceq>")
    (">>>*=" "<succsuccsucceq>")
    ("<<*/" "<nprecprec>")
    ("<<<*/" "<nprecprecprec>")
    (">>*/" "<nsuccsucc>")
    (">>>*/" "<nsuccsuccsucc>")
    ("<<*=/" "<nprecpreceq>")
    ("<<<*=/" "<nprecprecpreceq>")
    (">>*=/" "<nsuccsucceq>")
    (">>>*=/" "<nsuccsuccsucceq>")
    ("<*." "<precdot>")
    (".>*" "<dotsucc>")
    ("<*=." "<preceqdot>")
    (".>*=" "<dotsucceq>")

    ("<>" "<lessgtr>")
    ("><" "<gtrless>")
    ("<~" "<lesssim>")
    ("<~~" "<lessapprox>")
    ("<*~" "<precsim>")
    ("<*~~" "<precapprox>")
    (">~" "<gtrsim>")
    (">~~" "<gtrapprox>")
    (">*~" "<gtrsim>")
    (">*~~" "<gtrapprox>")
    ("<=**" "<leqq>")
    (">=**" "<geqq>")
    ("<=*>" "<lesseqgtr>")
    (">=*<" "<gtreqless>")
    ("<=**>" "<lesseqqgtr>")
    (">=**<" "<gtreqqless>")
    ("<>/" "<nlessgtr>")
    ("></" "<ngtrless>")
    ("<~/" "<nlesssim>")
    ("<~/*" "<lnsim>")
    ("<~~/" "<nlessapprox>")
    ("<~~/*" "<lnapprox>")
    ("<*~/" "<nprecsim>")
    ("<*~/*" "<precnsim>")
    ("<*~~/" "<nprecapprox>")
    ("<*~~/*" "<precnapprox>")
    (">~/" "<ngtrsim>")
    (">~/*" "<gnsim>")
    (">~~/" "<ngtrapprox>")
    (">~~/*" "<gnapprox>")
    (">*~/" "<nsuccsim>")
    (">*~/*" "<succnsim>")
    (">*~~/" "<nsuccapprox>")
    (">*~~/*" "<succnapprox>")
    ("<=**/" "<nleqq>")
    (">=**/" "<ngeqq>")
    ("<=*>/" "<nlesseqgtr>")
    (">=*</" "<ngtreqless>")
    ("<=**>/" "<nlesseqqgtr>")
    (">=**</" "<ngtreqqless>")
    ("<=*/*" "<lneq>")
    ("<=**/*" "<lneqq>")
    ("<=**/**" "<lvertneqq>")
    (">=*/*" "<gneq>")
    (">=**/*" "<gneqq>")
    (">=**/**" "<gvertneqq>")

    ("->" "<rightarrow>")
    ("<-" "<leftarrow>")
    ("<->" "<leftrightarrow>")
    ("-->" "<longrightarrow>")
    ("<--" "<longleftarrow>")
    ("<-->" "<longleftrightarrow>")
    ("=>" "<Rightarrow>")
    ("<=***" "<Leftarrow>")
    ("<=>" "<Leftrightarrow>")
    ("==>" "<Longrightarrow>")
    ("<==" "<Longleftarrow>")
    ("<==>" "<Longleftrightarrow>")
    ("|->" "<mapsto>")
    ("|-->" "<longmapsto>")
    ("<-|" "<mapsfrom>")
    ("<--|" "<longmapsfrom>")
    ("|->*" "<hookrightarrow>")
    ("<-|*" "<hookleftarrow>")
    ("~>" "<rightsquigarrow>")
    ("<~>" "<leftrightsquigarrow>")
    ("<-<" "<leftarrowtail>")
    (">->" "<rightarrowtail>")
    ("->->" "<rightrightarrows>")
    ("<-<-" "<leftleftarrows>")
    ("-><-" "<rightleftarrows>")
    ("-><-*" "<rightleftharpoons>")
    ("<-->*" "<leftrightarrows>")
    ("<-->**" "<leftrightharpoons>")
    ("->>" "<twoheadrightarrow>")
    ("<<-" "<twoheadleftarrow>")
    ("->/" "<nrightarrow>")
    ("<-/" "<nleftarrow>")
    ("<->/" "<nleftrightarrow>")
    ("=>/" "<nRightarrow>")
    ("<=***/" "<nLeftarrow>")
    ("<=>/" "<nLeftrightarrow>")
    ("<->-" "<leftrightarroweq>")
    ("-|>" "<rightarrowtriangle>")
    ("<|-" "<leftarrowtriangle>")
    ("<|-|>" "<leftrightarrowtriangle>")
    ("|-|>" "<longmapstotriangle>")
    ("--|>" "<longrightarrowtriangle>")
    ("<|--" "<longleftarrowtriangle>")
    ("<|--|>" "<longleftrightarrowtriangle>")
    ("|--|>" "<longmapstotriangle>")
    ("<-<*" "<leftprec>")
    (">*->" "<succright>")
    ("<-<*=" "<leftpreceq>")
    (">*=->" "<succeqright>")

    ("@" "<circ>")
    ("@/" "<varnothing>")
    ("@+" "<oplus>")
    ("@-" "<ominus>")
    ("@x" "<otimes>")
    ("@:" "<oover>")
    ("@." "<odot>")
    ("@R" "<circledR>")
    ("@S" "<circledS>")
    ("@/*" "<oslash>")
    ("@\\" "<obslash>")
    ("@<" "<olessthan>")
    ("@>" "<ogreaterthan>")
    ("@&" "<owedge>")
    ("@|" "<obar>")
    ("@|*" "<ovee>")
    ("@v" "<ovee>")
    ("@@" "<infty>")
    ("@@*" "<varocircle>")
    ("-@@" "-<infty>")
    ("@*" "<box>")
    ("@*+" "<boxplus>")
    ("@*-" "<boxminus>")
    ("@*x" "<boxtimes>")
    ("@*." "<boxdot>")
    ("@*/" "<boxslash>")
    ("@*\\" "<boxbslash>")
    ("@*@" "<boxcircle>")
    ("@*@*" "<boxbox>")
    ("@*|" "<boxbar>")
    ("@**" "<bullet>")
    ("@***" "<blacksquare>")

    ("=*" "<asymp>")
    ("=**" "<equiv>")
    ("=***" "<asympasymp>")
    ("=****" "<simsim>")
    ("~" "<sim>")
    ("~~" "<approx>")
    ("~~-" "<approxeq>")
    ("~-" "<simeq>")
    ("~=" "<cong>")
    ("=/" "<neq>")
    ("=*/" "<nasymp>")
    ("=**/" "<nequiv>")
    ("=***/" "<nasympasymp>")
    ("=****/" "<nsimsim>")
    ("~/" "<nsim>")
    ("~~/" "<napprox>")
    ("~-/" "<nsimeq>")
    ("~=/" "<ncong>")
    
    ("|" "|")
    ("|*" "<shortmid>")
    ("|**" "<varshortmid>")
    ("||" "<||>")
    ("|||" "<interleave>")
    ("||*" "<shortparallel>")
    ("|-" "<vdash>")
    ("||-" "<Vdash>")
    ("|||-" "<Vvdash>")
    ("-|" "<dashv>")
    ("|=" "<dashV>")
    ("||=" "<VDash>")
    ("|/" "<nmid>")
    ("||/" "<nparallel>")
    ("|*/" "<nshortmid>")
    ("||*/" "<nshortparallel>")
    ("|-/" "<nvdash>")
    ("||-/" "<nVdash>")
    ("-|/" "<ndashv>")
    ("-||/" "<ndashV>")
    ("|=/" "<nvDash>")
    ("||=/" "<nVDash>")
    ("=|/" "<nDashv>")
    ("=||/" "<nVashV>")
    
    ("<|" "<vartriangleleft>")
    ("<|*" "<blacktriangleleft>")
    ("<|/" "<ntriangleleft>")
    ("<|=" "<trianglelefteqslant>")
    ("<|=/" "<ntrianglelefteqslant>")
    ("<|=*" "<trianglelefteq>")
    ("<|=*/" "<ntriangleqleft>")
    ("|>" "<vartriangleright>")
    ("|>*" "<blacktriangleright>")
    ("|>/" "<ntriangleright>")
    ("|>=" "<trianglerighteq>")
    ("|>=/" "<ntriangleqright>")
    ("|>=*" "<trianglerighteqslant>")
    ("|>=*/" "<ntrianglerighteqslant>")
    
    ("+-" "<pm>")
    ("-+" "<mp>")
    ("@=" "<circeq>")
    ("=@" "<eqcirc>")
    ("-@" "<multimap>")
    (".=" "<doteq>")
    (".." "<ldots>")
    ("..*" "<cdots>")
    (":=" "<assign>")
    ("+=" "<plusassign>")
    ("-=" "<minusassign>")

    ("<**" "<subset>")
    (">**" "<supset>")
    ("<**/" "<nsubset>")
    (">**/" "<nsupset>")
    ("<**=" "<subseteq>")
    (">**=" "<supseteq>")
    ("<**=/" "<nsubseteq>")
    (">**=/" "<nsupseteq>")
    ("<**=*" "<subseteqq>")
    (">**=*" "<supseteqq>")
    ("<**=/" "<nsubseteq>")
    (">**=/" "<nsupseteq>")
    ("<**=*/" "<nsubseteqq>")
    (">**=*/" "<nsupseteqq>")
    ("<**=/*" "<subsetneq>")
    (">**=/*" "<supsetneq>")
    ("<**=/**" "<varsubsetneq>")
    (">**=/**" "<varsupsetneq>")
    ("<**=*/*" "<subsetneqq>")
    (">**=*/*" "<supsetneqq>")
    ("<**=*/**" "<varsubsetneqq>")
    (">**=*/**" "<varsupsetneqq>")
    ("<**+" "<subsetplus>")
    (">**+" "<supsetplus>")
    ("<**+=" "<subsetpluseq>")
    (">**+=" "<supsetpluseq>")
    ("<**=+" "<subsetpluseq>")
    (">**=+" "<supsetpluseq>")
    ("<***" "<in>")
    (">***" "<ni>")
    ("<***/" "<nin>")
    (">***/" "<nni>")

    ("<****" "<sqsubset>")
    (">****" "<sqsupset>")
    ("<****/" "<nsqsubset>")
    (">****/" "<nsqsupset>")
    ("<****=" "<sqsubseteq>")
    (">****=" "<sqsupseteq>")
    ("<****=/" "<nsqsubseteq>")
    (">****=/" "<nsqsupseteq>")

    ("<*****" "<langle>")
    (">*****" "<rangle>")
    ("<******" "<leftslice>")
    (">******" "<rightslice>")))
