
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : symbol-menu.scm
;; DESCRIPTION : for choosing TeXmacs symbols graphically from menu
;; COPYRIGHT   : (C) 1999  Joris van der Hoeven
;;
;; This software falls under the GNU general public licence and comes WITHOUT
;; ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for details.
;; If you don't have this file, write to the Free Software Foundation, Inc.,
;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;
;; Large delimiters
;;

(define left-delimiter-menu
  '((symbol () #{<left-(-2>}# #{<esc><esc>(}#)
    (symbol () #{<left-)-2>}# #{<esc><esc>l)}#)
    (symbol () <left-[-2> <esc><esc>[)
    (symbol () <left-]-2> <esc><esc>l])
    (symbol () <left-{-2> <esc><esc>{)
    (symbol () <left-}-2> <esc><esc>l})
    (symbol () <left-langle-2> <esc><esc><less>)
    (symbol () <left-rangle-2> <esc><esc>l<gtr>)
    (symbol () <left-lfloor-2> <esc><esc>|,)
    (symbol () <left-rfloor-2> <esc><esc>l,|)
    (symbol () <left-lceil-2> <esc><esc>|\')
    (symbol () <left-rceil-2> <esc><esc>l\'|)
    (symbol () <left-llbracket-2> <esc><esc>[[*)
    (symbol () <left-rrbracket-2> <esc><esc>l]]*)
    (symbol () <left-|-2> <esc><esc>l|)
    (symbol () <left-||-2> <esc><esc>l||)
    (symbol () <left-/-2> <esc><esc>l/)
    (symbol () #{<left-\\-2>}# <esc><esc>lb)))

(define middle-delimiter-menu
  '((symbol () #{<mid-(-2>}# #{<esc><esc>m(}#)
    (symbol () #{<mid-)-2>}# #{<esc><esc>m)}#)
    (symbol () <mid-[-2> <esc><esc>m[)
    (symbol () <mid-]-2> <esc><esc>m])
    (symbol () <mid-{-2> <esc><esc>m{)
    (symbol () <mid-}-2> <esc><esc>m})
    (symbol () <mid-langle-2> <esc><esc>m<less>)
    (symbol () <mid-rangle-2> <esc><esc>m<gtr>)
    (symbol () <mid-lfloor-2> <esc><esc>m|,)
    (symbol () <mid-rfloor-2> <esc><esc>m,|)
    (symbol () <mid-lceil-2> <esc><esc>m|\')
    (symbol () <mid-rceil-2> <esc><esc>m\'|)
    (symbol () <mid-llbracket-2> <esc><esc>m[[*)
    (symbol () <mid-rrbracket-2> <esc><esc>m]]*)
    (symbol () <mid-|-2> <esc><esc>|)
    (symbol () <mid-||-2> <esc><esc>||)
    (symbol () <mid-/-2> <esc><esc>/)
    (symbol () #{<mid-\\-2>}# <esc><esc>b)))

(define right-delimiter-menu
  '((symbol () #{<right-(-2>}# #{<esc><esc>r(}#)
    (symbol () #{<right-)-2>}# #{<esc><esc>)}#)
    (symbol () <right-[-2> <esc><esc>r[)
    (symbol () <right-]-2> <esc><esc>])
    (symbol () <right-{-2> <esc><esc>r{)
    (symbol () <right-}-2> <esc><esc>})
    (symbol () <right-langle-2> <esc><esc>r<less>)
    (symbol () <right-rangle-2> <esc><esc><gtr>)
    (symbol () <right-lfloor-2> <esc><esc>r|,)
    (symbol () <right-rfloor-2> <esc><esc>,|)
    (symbol () <right-lceil-2> <esc><esc>r|\')
    (symbol () <right-rceil-2> <esc><esc>\'|)
    (symbol () <right-llbracket-2> <esc><esc>r[[*)
    (symbol () <right-rrbracket-2> <esc><esc>]]*)
    (symbol () <right-|-2> <esc><esc>r|)
    (symbol () <right-||-2> <esc><esc>r||)
    (symbol () <right-/-2> <esc><esc>r/)
    (symbol () #{<right-\\-2>}# <esc><esc>rb)))

;;
;; Big operators
;;

(define big-operator-menu
  '((symbol () <big-sum-2> <esc><esc>S)
    (symbol () <big-prod-2> <esc><esc>P)
    (symbol () <big-int-2> <esc><esc>I)
    (symbol () <big-oint-2> <esc><esc>O)
    (symbol () <big-amalg-2> <esc><esc>A)
    (symbol () <big-cap-2> <esc><esc>N)
    (symbol () <big-cup-2> <esc><esc>U)
    (symbol () <big-wedge-2> <esc><esc>N*)
    (symbol () <big-vee-2> <esc><esc>U*)
    (symbol () <big-odot-2> <esc><esc>@.)
    (symbol () <big-oplus-2> <esc><esc>@+)
    (symbol () <big-otimes-2> <esc><esc>@x)
    (symbol () <big-sqcap-2> <esc><esc>N**)
    (symbol () <big-sqcup-2> <esc><esc>U**)
    (symbol () <big-curlywedge-2> <esc><esc>N***)
    (symbol () <big-curlyvee-2> <esc><esc>U***)
    (symbol () <big-triangleup-2> <esc><esc>N****)
    (symbol () <big-triangledown-2> <esc><esc>U****)
    (symbol () <big-box-2> <esc><esc>@*)
    (symbol () <big-pluscup-2> <esc><esc>U+)
    (symbol () <big-parallel-2> <esc><esc>||*)
    (symbol () <big-interleave-2> <esc><esc>|||)))

;;
;; Binary operations
;;

(define binary-operation-menu
  '((symbol () <oplus> @+)
    (symbol () <ominus> @-)
    (symbol () <otimes> @x)
    (symbol () <oslash> @/*)
    (symbol () <odot> @.)
    (symbol () <varocircle> @@*)
    (symbol () <circledast>)
    (symbol () <obar> @|)
    (symbol () <boxplus> @*+)
    (symbol () <boxminus> @*-)
    (symbol () <boxtimes> @*x)
    (symbol () <boxslash> @*/)
    (symbol () <boxdot> @.)
    (symbol () <boxbox> @*@*)
    (symbol () <boxast>)
    (symbol () <boxbar> @*|)

    (symbol () <pm> +-)
    (symbol () <mp> -+)
    (symbol () <times>)
    (symbol () <div>)
    (symbol () <asterisk>)
    (symbol () <star>)
    (symbol () <circ> @)
    (symbol () <bullet> @**)
    (symbol () <cdot>)
    (symbol () <cap>)
    (symbol () <cup>)
    (symbol () <uplus>)
    (symbol () <sqcap>)
    (symbol () <sqcup>)
    (symbol () <vee>)
    (symbol () <wedge>)
    (symbol () <wr>)
))

;;
;; Binary relations
;;

(define binary-relation-menu-1
  '((symbol () <sim> ~)
    (symbol () <simeq> ~-)
    (symbol () <approx> ~~)
    (symbol () <cong> ~=)
    (symbol () <asymp> =*)
    (symbol () <equiv> =**)
    (symbol () <asympasymp> =***)
    (symbol () <simsim> =****)
    (symbol () <bumpeq>)
    (symbol () <Bumpeq>)
    (symbol () <circeq> @=)
    (symbol () <backsim>)
    (symbol () <backsimeq>)
    (symbol () <eqcirc> =@)
    (symbol () <thicksim>)
    (symbol () <thickapprox>)
    (symbol () <approxeq> ~~-)
    (symbol () <triangleq>)
    (symbol () <neq> =/)
    (symbol () <nin>)
    (symbol () <perp>)
    (symbol () <smile>)
    (symbol () <frown>)
    (symbol () <propto>)))

(define binary-relation-menu-2
  '((symbol () <less> <less>)
    (symbol () <leqslant> <less>=)
    (symbol () <leq> <less>=*)
    (symbol () <leqq> <less>=**)
    (symbol () <ll> <less><less>)
    (symbol () <lleq> <less><less>=)
    (symbol () <lll> <less><less><less>)
    (symbol () <llleq> <less><less><less>=)
    (symbol () <gtr> <gtr>)
    (symbol () <geqslant> <gtr>=)
    (symbol () <geq> <gtr>=*)
    (symbol () <geqq> <gtr>=**)
    (symbol () <gg> <gtr><gtr>)
    (symbol () <ggeq> <gtr><gtr>=)
    (symbol () <ggg> <gtr><gtr><gtr>)
    (symbol () <gggeq> <gtr><gtr><gtr>=)

    (symbol () <prec> <less>*)
    (symbol () <preccurlyeq> <less>*=)
    (symbol () <preceq> <less>*=*)
    (symbol () <precsim> <less>*~)
    (symbol () <precprec> <less><less>*)
    (symbol () <precpreceq> <less><less>*=)
    (symbol () <precprecprec> <less><less><less>*)
    (symbol () <precprecpreceq> <less><less><less>*=)
    (symbol () <succ> <gtr>*)
    (symbol () <succcurlyeq> <gtr>*=)
    (symbol () <succeq> <gtr>*=*)
    (symbol () <succsim> <gtr>*~)
    (symbol () <succsucc> <gtr><gtr>*)
    (symbol () <succsucceq> <gtr><gtr>*=)
    (symbol () <succsuccsucc> <gtr><gtr><gtr>*)
    (symbol () <succsuccsucceq> <gtr><gtr><gtr>*=)

    (symbol () <subset> <less>**)
    (symbol () <subseteq> <less>**=)
    (symbol () <subseteqq> <less>**=*)
    (symbol () <sqsubset> <less>****)
    (symbol () <sqsubseteq> <less>****=)
    (symbol () <Subset>)
    (symbol () <subsetplus> <less>**+)
    (symbol () <in> <less>***)
    (symbol () <supset> <gtr>**)
    (symbol () <supseteq> <gtr>**=)
    (symbol () <supseteqq> <gtr>**=*)
    (symbol () <sqsupset> <gtr>****)
    (symbol () <sqsupseteq> <gtr>****=)
    (symbol () <Supset>)
    (symbol () <supsetplus> <gtr>**+)
    (symbol () <ni> <gtr>***)

    (symbol () <vartriangleleft> <less>|)
    (symbol () <trianglelefteqslant> <less>|=)
    (symbol () <trianglelefteq> <less>|=*)
    (symbol () <blacktriangleleft> <less>|*)
    (symbol () <lesssim> <less>~)
    (symbol () <lessapprox> <less>~~)
    (symbol () <precsim> <less>*~)
    (symbol () <precapprox> <less>*~~)
    (symbol () <vartriangleright> |<gtr>)
    (symbol () <trianglerighteqslant> |<gtr>=)
    (symbol () <trianglerighteq> |<gtr>=*)
    (symbol () <blacktriangleright> |<gtr>*)
    (symbol () <gtrsim> <gtr>~)
    (symbol () <gtrapprox> <gtr>~~)
    (symbol () <succsim> <gtr>*~)
    (symbol () <succapprox> <gtr>*~~)))

;;
;; Arrows
;;

(define horizontal-arrow-menu
  '((symbol () <leftarrow> <less>-)
    (symbol () <Leftarrow> <less>=***)
    (symbol () <leftharpoonup>)
    (symbol () <leftharpoondown>)
    (symbol () <leftleftarrows> <less>-<less>-)
    (symbol () <leftarrowtail> <less>-<less>)
    (symbol () <hookleftarrow>)
    (symbol () <looparrowleft>)
    (symbol () <twoheadleftarrow> <less><less>-)

    (symbol () <rightarrow> -<gtr>)
    (symbol () <Rightarrow> =<gtr>)
    (symbol () <rightharpoonup>)
    (symbol () <rightharpoondown>)
    (symbol () <rightrightarrows> -<gtr>-<gtr>)
    (symbol () <rightarrowtail> <gtr>-<gtr>)
    (symbol () <hookrightarrow>)
    (symbol () <looparrowright>)
    (symbol () <twoheadrightarrow> -<gtr><gtr>)

    (symbol () <leftrightarrow> <less>-<gtr>)
    (symbol () <Leftrightarrow> <less>=<gtr>)
    (symbol () <leftrightharpoons> <less>--<gtr>**)
    (symbol () <rightleftharpoons> -<gtr><less>-*)
    (symbol () <leftrightarrows> <less>--<gtr>*)
    (symbol () <rightleftarrows> -<gtr><less>-)
    (symbol () <mapsto> |-<gtr>)
    (symbol () <rightsquigarrow> ~<gtr>)
    (symbol () <leftrightsquigarrow> <less>~<gtr>)))

(define vertical-arrow-menu
  '((symbol () <uparrow>)
    (symbol () <Uparrow>)
    (symbol () <upuparrows>)
    (symbol () <upharpoonleft>)
    (symbol () <upharpoonright>)
    (symbol () <nwarrow>)
    (symbol () <nearrow>)
    (symbol () <updownarrow>)

    (symbol () <downarrow>)
    (symbol () <Downarrow>)
    (symbol () <downdownarrows>)
    (symbol () <downharpoonleft>)
    (symbol () <downharpoonright>)
    (symbol () <swarrow>)
    (symbol () <searrow>)
    (symbol () <Updownarrow>)))

(define long-arrow-menu
  '((symbol () <longleftarrow> <less>--)
    (symbol () <longrightarrow> --<gtr>)
    (symbol () <longleftrightarrow> <less>--<gtr>)
    (symbol () <Longleftarrow> <less>==)
    (symbol () <Longrightarrow> ==<gtr>)
    (symbol () <Longleftrightarrow> <less>==<gtr>)
    (symbol () <longhookleftarrow>)
    (symbol () <longhookrightarrow>)
    (symbol () <longmapsto> |--<gtr>)))

;;
;; Negations
;;

(define negation-menu
  '((symbol () <lneq> <less>=*/*)
    (symbol () <lneqq> <less>=**/*)
    (symbol () <lvertneqq> <less>=**/**)
    (symbol () <lnsim> <less>~/*)
    (symbol () <lnapprox> <less>~~/*)
    (symbol () <precneqq> <less>*=*/*)
    (symbol () <gneq> <gtr>=*/*)
    (symbol () <gneqq> <gtr>=**/*)
    (symbol () <gvertneqq> <gtr>=**/**)
    (symbol () <gnsim> <gtr>~/*)
    (symbol () <gnapprox> <gtr>~~/*)
    (symbol () <succneqq> <gtr>*=*/*)

    (symbol () <precnsim> <less>*~/*)
    (symbol () <precnapprox> <less>*~~/*)
    (symbol () <subsetneq> <less>**=/*)
    (symbol () <subsetneqq> <less>**=*/*)
    (symbol () <varsubsetneq> <less>**=/**)
    (symbol () <varsubsetneqq> <less>**=*/**)
    (symbol () <succnsim> <gtr>*~/*)
    (symbol () <succnapprox> <gtr>*~~/*)
    (symbol () <supsetneq> <gtr>**=/*)
    (symbol () <supsetneqq> <gtr>**=*/*)
    (symbol () <varsupsetneq> <gtr>**=/**)
    (symbol () <varsupsetneqq> <gtr>**=*/**)))

;;
;; Greek characters
;;

(define lower-greek-menu
  '((symbol () <alpha> <alt-a>)
    (symbol () <beta> <alt-b>)
    (symbol () <gamma> <alt-g>)
    (symbol () <delta> <alt-d>)
    (symbol () <epsilon> <alt-e>*)
    (symbol () <varepsilon> <alt-e>)
    (symbol () <zeta> <alt-z>)
    (symbol () <eta> <alt-h>)
    (symbol () <theta> <alt-q>)
    (symbol () <vartheta> <alt-q>*)
    (symbol () <iota> <alt-i>)
    (symbol () <kappa> <alt-k>)
    (symbol () <lambda> <alt-l>)
    (symbol () <mu> <alt-m>)
    (symbol () <nu> <alt-n>)
    (symbol () <xi> <alt-x>)
    (symbol () <omicron> <alt-o>)
    (symbol () <pi> <alt-p>)
    (symbol () <varpi> <alt-p>*)
    (symbol () <rho> <alt-r>)
    (symbol () <varrho> <alt-r>*)
    (symbol () <sigma> <alt-s>)
    (symbol () <varsigma> <alt-s>*)
    (symbol () <tau> <alt-t>)
    (symbol () <upsilon> <alt-u>)
    (symbol () <phi> <alt-f>*)
    (symbol () <varphi> <alt-f>)
    (symbol () <chi> <alt-c>)
    (symbol () <psi> <alt-y>)
    (symbol () <omega> <alt-w>)))

(define upper-greek-menu
  '((symbol () <Gamma> <alt-G>)
    (symbol () <Delta> <alt-D>)
    (symbol () <Theta> <alt-Q>)
    (symbol () <Lambda> <alt-L>)
    (symbol () <Xi> <alt-X>)
    (symbol () <Pi> <alt-P>)
    (symbol () <Sigma> <alt-S>)
    (symbol () <Upsilon> <alt-U>)
    (symbol () <Phi> <alt-F>)
    (symbol () <Psi> <alt-Y>)
    (symbol () <Omega> <alt-W>)))

;;
;; Miscellaneous symbols
;;

(define miscellaneous-symbol-menu
  '((symbol () <aleph>)
    (symbol () <beth>)
    (symbol () <gimel>)
    (symbol () <daleth>)
    (symbol () <imath>)
    (symbol () <jmath>)
    (symbol () <ell>)
    (symbol () <wp>)
    (symbol () <Re>)
    (symbol () <Im>)
    (symbol () <Mho>)
    (symbol () <emptyset>)
    (symbol () <varnothing>)
    (symbol () <nabla>)
    (symbol () <top>)
    (symbol () <bot>)
    (symbol () <vdash> |-)
    (symbol () <Vdash> ||-)
    (symbol () <Vvdash> |||-)
    (symbol () <dashV> |=)
    (symbol () <dashv> -|)
    (symbol () <angle>)
    (symbol () <forall>)
    (symbol () <exists>)
    (symbol () <neg>)
    (symbol () <flat>)
    (symbol () <natural>)
    (symbol () <sharp>)
    (symbol () <backslash>)
    (symbol () <partial>)
    (symbol () <infty>)
    (symbol () <box>)
    (symbol () <diamond>)
    (symbol () <triangle>)
    (symbol () <clubsuit>)
    (symbol () <diamondsuit>)
    (symbol () <heartsuit>)
    (symbol () <spadesuit>)
    (symbol () <sun>)
    (symbol () <leftmoon>)
    (symbol () <rightmoon>)
    (symbol () <earth>)
    (symbol () <male>)
    (symbol () <female>)
    (symbol () <maltese>)
    (symbol () <kreuz>)
    (symbol () <recorder>)
    (symbol () <phone>)
    (symbol () <checked>)
    (symbol () <pointer>)
    (symbol () <bell>)
    (symbol () <eighthnote>)
    (symbol () <quarternote>)
    (symbol () <halfnote>)
    (symbol () <fullnote>)
    (symbol () <twonotes>)))
